# 
# Copyright (C) 1996-2001 LAAS/CNRS 
# All rights reserved.
# 
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 
#    - Redistributions of source code must retain the above copyright
#      notice, this list of conditions and the following disclaimer.
#    - Redistributions in binary form must reproduce the above
#      copyright notice, this list of conditions and the following
#      disclaimer in the documentation and/or other materials provided
#      with the distribution.
# 
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
# FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
# COPYRIGHT HOLDERS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
# BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
# LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
# CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
# ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.
# 
# $LAAS$
#----------------------------------------------------------------------
package provide Gdhe::models 1.0

###
### Junior
###

proc junior {{l "unload"}} {

    object Junior {
	cullFace True
	
	# prisme principal
	color 200 200 200
	prism 8 +0.0   +0.0   +0.510 \
	    -0.370 +0.295 +0.230  \
	    +0.370 +0.295 +0.230 \
	    +0.450 +0.260 +0.230 \
	    +0.450 -0.260 +0.230 \
	    +0.370 -0.295 +0.230 \
	    -0.370 -0.295 +0.230 \
	    -0.450 -0.260 +0.230 \
	    -0.450  0.260 +0.230
	# 
	# color 30 30 30 
	# prism 8 +0.0   +0.0   +0.005 \
	    -0.371 +0.296 +0.734 \
	    +0.371 +0.296 +0.734 \
	    +0.451 +0.261 +0.734 \
	    +0.451 -0.261 +0.734 \
	    +0.371 -0.296 +0.734 \
	    -0.371 -0.296 +0.734 \
	    -0.451 -0.261 +0.734 \
	    -0.451  0.261 +0.734
	# clignotants
	color 255 50 0
	cylinder 0.45  0.2    0.6 x     0.05   0.005
	cylinder 0.45  -0.2   0.6 x     0.05   0.005
	# roues
	color 40 40 40
	cylinder +0.0 -0.245 0.15 y 0.3 0.05
	cylinder +0.0 +0.240 0.15  y 0.3 0.05
	cylinder 0.400 -0.225 0.075 y 0.15 0.05
	cylinder 0.400 +0.220 0.075 y 0.15 0.05
	cylinder -0.400 -0.225 0.075 y 0.15 0.05
	cylinder -0.400 +0.220 0.075 y 0.15 0.05
	# partie blue
	color 0 40 100 
	prism 6 +0.0   +0.0   +0.100 \
	    -0.450 +0.295 +0.130 \
	    +0.370 +0.295 +0.130 \
	    +0.450 +0.260 +0.130 \
	    +0.450 -0.260 +0.130 \
	    +0.370 -0.295 +0.130 \
	    -0.450 -0.295 +0.130
	# bumpers
	color 40 40 40
	prism 6 +0.0   +0.0   +0.150 \
	    +0.400 +0.325 +0.230 \
	    +0.450 +0.325 +0.230 \
	    +0.550 +0.260 +0.230 \
	    +0.550 -0.260 +0.230 \
	    +0.450 -0.325 +0.230 \
	    +0.400 -0.325 +0.230
	prism 6 +0.0   +0.0   +0.150 \
	    -0.550 -0.260 +0.230 \
	    -0.550 +0.260 +0.230 \
	    -0.500 +0.325 +0.230 \
	    -0.450 +0.325 +0.230 \
	    -0.450 -0.325 +0.230 \
	    -0.500 -0.325 +0.230
	prism 4 +0.0   +0.0   +0.150 \
	    -0.400 -0.325 +0.230 \
	    -0.400 -0.295 +0.230 \
	    +0.350 -0.295 +0.230 \
	    +0.350 -0.325 +0.230
	prism 4 +0.0   +0.0   +0.150 \
	    -0.400 +0.295 +0.230 \
	    -0.400 +0.325 +0.230 \
	    +0.350 +0.325 +0.230 \
	    +0.350 +0.295 +0.230 
    }
    if {![string compare $l load ]} {
	# Dessin le container dans le robot
	object container_junior {
	    color 180 13 50
	    # :cube container
	    box -.15 0.0 .72	.4 .5 .12
	}
    }
}

proc junior_platform {angle} {

    pushMatrix
    rotate $angle 0 0 1
    
    object Junior_platform {
	color 160 160 160
	box 0.0 0.0 0.740 0.300 0.350 0.010
	color 0 40 100 
	box 0.0 0.0 0.741 0.300 0.250 0.10
	 color 30 30 30
	box 0.0 0.0 0.742 0.302 0.248 0.098
    }
    popMatrix
}
